%%
clc;
clear all;
close all;
tfinal = 13000;
stepsize = .1;
L = tfinal/stepsize;
tvals = 0:stepsize:tfinal;
minTime = Inf;
maxTime = 0;
PatientNumber = 1000;
nA = 6.023e23;              % Avagadro's number
vol = 29e-15;               % volume of Yeast Cell 
%% Threshold Determination

x0=zeros(18,1);
x0(1) = 0.2;
x0(2) = 0.2;
x0(3) = 0;
x0(4) = 1.667;
x0(5) = 0.0;
x0(6) = 0.686;
x0(7) = 0.0;
x0(8) = 1.667;
x0(9) = 0.0;
x0(10) = 0.0;
x0(11) = 0.0;
x0(12) = 0.505;
x0(13) = 0.0;
x0(14) = 0.0;
x0(15) = 0.036;
x0(16) = 0;
x0(17) = 0;
x0(18) = 0;
[t,y] = ode23s('Snifferomyces',tvals,x0);
TBGFP = y(:,17);
Threshold = max(y(:,17));

%% False Positive Test - LigandConcentration : 0 - 0.19 [uM]
%Waitbar Assignment
% hfn = waitbar(0,'Please wait False Positive Test Underway...');
clc;close all;clear Ste12a;clear gfp_fp;
a = 0;
b = 0.19;
Lp =  a + (b-a).*rand(PatientNumber/2,1);
FpCount = 0;
x0=zeros(18,1);
x0(2) = 0.2;
x0(3) = 0;
x0(4) = 1.667;
x0(5) = 0.0;
x0(6) = 0.686;
x0(7) = 0.0;
x0(8) = 1.667;
x0(9) = 0.0;
x0(10) = 0.0;
x0(11) = 0.0;
x0(12) = 0.505;
x0(13) = 0.0;
x0(14) = 0.0;
x0(15) = 0.036;
x0(16) = 0;
x0(17) = 0;
x0(18) = 0;

for i = 1:PatientNumber/2
    i
    x0(1) = Lp(i);
    [t,y] = ode23s('Snifferomyces',tvals,x0);
    gfp = GeneExpressionSDE(y(:,3));
    gfp_fp(:,i) = gfp;
    if max(gfp_fp(:,i))>Threshold
        FpCount = FpCount + 1;
    end
%     waitbar((PatientNumber/(2*i)));
end
% close(hfn)

%% False Negative Test - LigandConcentration : 0.2 - 20 [uM]
close all;
a = 0.2;
b = 2;
Ln =  a + (b-a).*rand(PatientNumber/2,1);
FnCount = 0;
clear gfp_fn;
x0=zeros(18,1);
x0(2) = 0.2;
x0(3) = 0;
x0(4) = 1.667;
x0(5) = 0.0;
x0(6) = 0.686;
x0(7) = 0.0;
x0(8) = 1.667;
x0(9) = 0.0;
x0(10) = 0.0;
x0(11) = 0.0;
x0(12) = 0.505;
x0(13) = 0.0;
x0(14) = 0.0;
x0(15) = 0.036;
x0(16) = 0;
x0(17) = 0;
x0(18) = 0;

for j = 1:PatientNumber/2
    j
    x0(1) = Ln(j);
    [t,y] = ode23s('Snifferomyces',tvals,x0);
    gfp = GeneExpressionSDE(y(:,3));
    gfp_fn(:,j) = gfp;
    if max(gfp_fn(:,i))<Threshold
        FnCount = FnCount + 1;
    end
%     waitbar((PatientNumber/2)+((PatientNumber/2)/i));
end
%% Plotting the results
% close(h);
plot(t,TBGFP,'k--','LineWidth',10);hold on;legend('Threshold')
plot(t,gfp_fp);plot(t,gfp_fn);hold off;
%% False Negative
for c = 1:500
    if max(gfp_fn(:,c))<Threshold
        FnCount = FnCount + 1;
    end
end
